using System;
using System.Collections;
using Server;
using Server.Prompts;
using Server.Mobiles;
using Server.ContextMenus;
using Server.Gumps;
using Server.Items;
using Server.Network;
using Server.Targeting;
using Server.Multis;
using Server.Regions;


namespace Server.Items
{
        [FlipableAttribute( 0xE41, 0xE40 )]
        public class NewGraniteBox : BaseContainer
        {
                // RWR MODIFIED FOR PERN ORES
				private int m_Blaze;
                private int m_Ice;
                private int m_Toxic;
                private int m_Electrum;
                private int m_Platinum;
                //private int m_Moonstone;
                //private int m_Sunstone;
                //private int m_Bloodstone;
                //private int m_Vulcan;
                //private int m_Aqua;
				// END RWR

                // RWR MODIFY FOR PERN ORES
				[CommandProperty( AccessLevel.GameMaster )]
                public int Blaze{ get{ return m_Blaze; } set{ m_Blaze = value; InvalidateProperties(); } }

                [CommandProperty( AccessLevel.GameMaster )]
                public int Ice{ get{ return m_Ice; } set{ m_Ice = value; InvalidateProperties(); } }

                [CommandProperty( AccessLevel.GameMaster )]
                public int Toxic{ get{ return m_Toxic; } set{ m_Toxic = value; InvalidateProperties(); } }

                [CommandProperty( AccessLevel.GameMaster )]
                public int Electrum{ get{ return m_Electrum; } set{ m_Electrum = value; InvalidateProperties(); } }

				[CommandProperty( AccessLevel.GameMaster )]
                public int Platinum{ get{ return m_Platinum; } set{ m_Platinum = value; InvalidateProperties(); } }

                /*[CommandProperty( AccessLevel.GameMaster )]
                public int Moonstone{ get{ return m_Moonstone; } set{ m_Moonstone = value; InvalidateProperties(); } }

                [CommandProperty( AccessLevel.GameMaster )]
                public int Sunstone{ get{ return m_Sunstone; } set{ m_Sunstone = value; InvalidateProperties(); } }

                [CommandProperty( AccessLevel.GameMaster )]
                public int Bloodstone{ get{ return m_Bloodstone; } set{ m_Bloodstone = value; InvalidateProperties(); } }

                [CommandProperty( AccessLevel.GameMaster )]
                public int Vulcan{ get{ return m_Vulcan; } set{ m_Vulcan = value; InvalidateProperties(); } }

                [CommandProperty( AccessLevel.GameMaster )]
                public int Aqua{ get{ return m_Aqua; } set{ m_Aqua = value; InvalidateProperties(); } }*/
				// END RWR

                [Constructable]
                public NewGraniteBox() : base( 0xE41 )
                {
                        Movable = true;
                        Weight = 100.0;
                        Hue = 339;
                        Name = "New Style Granite Box";
						MaxItems = 1;
                }

                public override void OnDoubleClick( Mobile from )
                {
                        if ( Movable )
                        {
                                from.SendMessage( "You haven't locked it down!" );
                                return;
                        }
                        if ( !from.InRange( GetWorldLocation(), 2 ) )
                                from.LocalOverheadMessage( Network.MessageType.Regular, 0x3B2, 1019045 ); // I can't reach that.
                        else if ( from is PlayerMobile )
                                from.SendGump( new NewGraniteBoxGump( (PlayerMobile)from, this ) );
                }
				
				// Added by RWR 050204 to prevent items from dropping in container
				public override bool OnDragDrop ( Mobile from, Item dropped)
				{
					return false;
				}
				// End RWR

                public void BeginCombine( Mobile from )
                {
                                from.Target = new NewGraniteBoxTarget( this );
                }

                public void EndCombine( Mobile from, object o )
                {
                        if ( o is Item && ((Item)o).IsChildOf( from.Backpack ) )
                        {
                                
                                
								if (!( o is BaseGranite ))
                                {
                                        from.SendMessage( "That is not granite." );
                                }
                                // RWR EACH PERN ORE MUST BE ADDED TO AN IF LOOP
								if ( o is BlazeGranite )
                                {
                                        if ( Blaze >= 500 )
                                                from.SendMessage( "That granite type is too full to add more." );
                                        else
                                        {
                                                ((Item)o).Delete();
                                                Blaze = ( Blaze + 1 );
                                                from.SendGump( new NewGraniteBoxGump( (PlayerMobile)from, this ) );
                                                BeginCombine( from );
                                        }
                                }
                                if ( o is IceGranite )
                                {
                                        if ( Ice >= 500 )
                                                from.SendMessage( "That granite type is too full to add more." );
                                        else
                                        {
                                                ((Item)o).Delete();
                                                Ice = ( Ice + 1 );
                                                from.SendGump( new NewGraniteBoxGump( (PlayerMobile)from, this ) );
                                                BeginCombine( from );
                                        }
                                }
                                if ( o is ToxicGranite )
                                {
                                        if ( Toxic >= 500 )
                                                from.SendMessage( "That granite type is too full to add more." );
                                        else
                                        {
                                                ((Item)o).Delete();
                                                Toxic = ( Toxic + 1 );
                                                from.SendGump( new NewGraniteBoxGump( (PlayerMobile)from, this ) );
                                                BeginCombine( from );
                                        }
                                }
                                if ( o is ElectrumGranite )
                                {
                                        if ( Electrum >= 500 )
                                                from.SendMessage( "That granite type is too full to add more." );
                                        else
                                        {
                                                ((Item)o).Delete();
                                                Electrum = ( Electrum + 1 );
                                                from.SendGump( new NewGraniteBoxGump( (PlayerMobile)from, this ) );
                                                BeginCombine( from );
                                        }
                                }
                                if ( o is PlatinumGranite )
                                {
                                        if ( Platinum >= 500 )
                                                from.SendMessage( "That granite type is too full to add more." );
                                        else
                                        {
                                                ((Item)o).Delete();
                                                Platinum = ( Platinum + 1 );
                                                from.SendGump( new NewGraniteBoxGump( (PlayerMobile)from, this ) );
                                                BeginCombine( from );
                                        }
                                }
                                /*if ( o is MoonstoneGranite )
                                {
                                        if ( Moonstone >= 500 )
                                                from.SendMessage( "That granite type is too full to add more." );
                                        else
                                        {
                                                ((Item)o).Delete();
                                                Moonstone = ( Moonstone + 1 );
                                                from.SendGump( new NewGraniteBoxGump( (PlayerMobile)from, this ) );
                                                BeginCombine( from );
                                        }
                                }
                                if ( o is SunstoneGranite )
                                {
                                        if ( Sunstone >= 500 )
                                                from.SendMessage( "That granite type is too full to add more." );
                                        else
                                        {
                                                ((Item)o).Delete();
                                                Sunstone = ( Sunstone + 1 );
                                                from.SendGump( new NewGraniteBoxGump( (PlayerMobile)from, this ) );
                                                BeginCombine( from );
                                        }
                                }
                                if ( o is BloodstoneGranite )
                                {
                                        if ( Bloodstone >= 500 )
                                                from.SendMessage( "That granite type is too full to add more." );
                                        else
                                        {
                                                ((Item)o).Delete();
                                                Bloodstone = ( Bloodstone + 1 );
                                                from.SendGump( new NewGraniteBoxGump( (PlayerMobile)from, this ) );
                                                BeginCombine( from );
                                        }
                                }
                                if ( o is VulcanGranite )
                                {
                                        if ( Vulcan >= 500 )
                                                from.SendMessage( "That granite type is too full to add more." );
                                        else
                                        {
                                                ((Item)o).Delete();
                                                Vulcan = ( Vulcan + 1 );
                                                from.SendGump( new NewGraniteBoxGump( (PlayerMobile)from, this ) );
                                                BeginCombine( from );
                                        }
                                }
                                if ( o is AquaGranite )
                                {
                                        if ( Aqua >= 500 )
                                                from.SendMessage( "That granite type is too full to add more." );
                                        else
                                        {
                                                ((Item)o).Delete();
                                                Aqua = ( Aqua + 1 );
                                                from.SendGump( new NewGraniteBoxGump( (PlayerMobile)from, this ) );
                                                BeginCombine( from );
                                        }
                                }*/
								//  END RWR
                        }
                        else
                        {
                                from.SendLocalizedMessage( 1045158 ); // You must have the item in your backpack to target it.
                        }
               	}

                public NewGraniteBox( Serial serial ) : base( serial )
                {
                }

                                public override void Serialize( GenericWriter writer ) 
		                { 
		                        base.Serialize( writer ); 
		
		                        // RWR MODIFY FOR PERN ORES
								writer.Write( (int) m_Blaze); 
		                        writer.Write( (int) m_Ice); 
		                        writer.Write( (int) m_Toxic); 
		                        writer.Write( (int) m_Electrum); 
		                        writer.Write( (int) m_Platinum); 
		                        //writer.Write( (int) m_Moonstone); 
		                        //writer.Write( (int) m_Sunstone); 
		                        //writer.Write( (int) m_Bloodstone); 
		                        //writer.Write( (int) m_Vulcan); 
		                        //writer.Write( (int) m_Aqua); 
								//END RWR
		
		                } 
		
		                public override void Deserialize( GenericReader reader ) 
		                { 
		                        base.Deserialize( reader ); 
		
		                        //RWR MODIFY FOR PERN ORES
								m_Blaze = reader.ReadInt(); 
		                        m_Ice = reader.ReadInt(); 
		                        m_Toxic = reader.ReadInt(); 
		                        m_Electrum = reader.ReadInt(); 
		                        m_Platinum = reader.ReadInt(); 
		                        //m_Moonstone = reader.ReadInt(); 
		                        //m_Sunstone = reader.ReadInt(); 
		                        //m_Bloodstone = reader.ReadInt(); 
		                        //m_Vulcan = reader.ReadInt(); 
		                        //m_Aqua = reader.ReadInt(); 
								//END RWR
		                } 
		        } 
		} 
		


namespace Server.Items
{
        public class NewGraniteBoxGump : Gump
        {
                private PlayerMobile m_From;
                private NewGraniteBox m_Box;

                public NewGraniteBoxGump( PlayerMobile from, NewGraniteBox box ) : base( 25, 25 )
                {
                        m_From = from;
                        m_Box = box;

                        m_From.CloseGump( typeof( NewGraniteBoxGump ) );

                        AddPage( 0 );

                        AddBackground( 50, 10, 455, 260, 5054 );
                        AddImageTiled( 58, 20, 438, 241, 2624 );
                        AddAlphaRegion( 58, 20, 438, 241 );

                        AddLabel( 225, 25, 0x480, "New Style Granite Box" );

                        // RWR MODIFY FOR PERN ORES
						AddLabel( 125, 50, 0x486, "Blaze" );
                        AddLabel( 225, 50, 0x480, box.Blaze.ToString() );
                        AddButton( 75, 50, 4005, 4007, 1, GumpButtonType.Reply, 0 );
                        AddLabel( 125, 75, 0x486, "Ice" );
                        AddLabel( 225, 75, 0x480, box.Ice.ToString() );
                        AddButton( 75, 75, 4005, 4007, 2, GumpButtonType.Reply, 0 );
                        AddLabel( 125, 100, 0x486, "Toxic" );
                        AddLabel( 225, 100, 0x480, box.Toxic.ToString() );
                        AddButton( 75, 100, 4005, 4007, 3, GumpButtonType.Reply, 0 );
                        AddLabel( 125, 125, 0x486, "Electrum" );
                        AddLabel( 225, 125, 0x480, box.Electrum.ToString() );
                        AddButton( 75, 125, 4005, 4007, 4, GumpButtonType.Reply, 0 );
                        AddLabel( 125, 150, 0x486, "Platinum" );
                        AddLabel( 225, 150, 0x480, box.Platinum.ToString() );
                        AddButton( 75, 150, 4005, 4007, 5, GumpButtonType.Reply, 0 );
                        /*AddLabel( 325, 50, 0x486, "Moonstone" );
                        AddLabel( 425, 50, 0x480, box.Moonstone.ToString() );
                        AddButton( 275, 50, 4005, 4007, 6, GumpButtonType.Reply, 0 );
                        AddLabel( 325, 75, 0x486, "Sunstone" );
                        AddLabel( 425, 75, 0x480, box.Sunstone.ToString() );
                        AddButton( 275, 75, 4005, 4007, 7, GumpButtonType.Reply, 0 );
                        AddLabel( 325, 100, 0x486, "Bloodstone" );
                        AddLabel( 425, 100, 0x480, box.Bloodstone.ToString() );
                        AddButton( 275, 100, 4005, 4007, 8, GumpButtonType.Reply, 0 );
                        AddLabel( 325, 125, 0x984, "Vulcan" );
                        AddLabel( 425, 125, 0x480, box.Vulcan.ToString() );
                        AddButton( 275, 125, 4005, 4007, 9, GumpButtonType.Reply, 0 );
                        AddLabel( 325, 150, 0x985, "Aqua" );
                        AddLabel( 425, 150, 0x480, box.Aqua.ToString() );
                        AddButton( 275, 150, 4005, 4007, 10, GumpButtonType.Reply, 0 );*/
						// END RWR
                        
                        AddButton( 275, 200, 4005, 4007, 9, GumpButtonType.Reply, 0 );
                        AddLabel( 325, 200, 0x486, "Add Granite" );
                        
                }

                public override void OnResponse( NetState sender, RelayInfo info )
                {
                        if ( m_Box.Deleted )
                                return;

                        // RWR MODIFY BUTTON CHECKS FOR PERN ORES
						if ( info.ButtonID == 1 )
                        {
                                if ( m_Box.Blaze > 0 )
                                {
                                        m_Box.Blaze = ( m_Box.Blaze - 1 );
                                        m_From.AddToBackpack( new BlazeGranite() );
                                        m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                }
                                else
                                {
                                        m_From.SendMessage( "You do not have any of that granite!" );
                                        m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                }
                        }
                        if ( info.ButtonID == 2 )
                        {
                                if ( m_Box.Ice > 0 )
                                {
                                        m_Box.Ice = ( m_Box.Ice - 1 );
                                        m_From.AddToBackpack( new IceGranite() );
                                        m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                }
                                else
                                {
                                        m_From.SendMessage( "You do not have any of that granite!" );
                                        m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                }
                        }
                        if ( info.ButtonID == 3 )
                        {
                                if ( m_Box.Toxic > 0 )
                                {
                                        m_Box.Toxic = ( m_Box.Toxic - 1 );
                                        m_From.AddToBackpack( new ToxicGranite() );
                                        m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                }
                                else
                                {
                                        m_From.SendMessage( "You do not have any of that granite!" );
                                        m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                }
                        }
                        if ( info.ButtonID == 4 )
                        {
                                if ( m_Box.Electrum > 0 )
                                {
                                        m_Box.Electrum = ( m_Box.Electrum - 1 );
                                        m_From.AddToBackpack( new ElectrumGranite() );
                                        m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                }
                                else
                                {
                                        m_From.SendMessage( "You do not have any of that granite!" );
                                        m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                }
                        }
                        if ( info.ButtonID == 5 )
                        {
                                if ( m_Box.Platinum > 0 )
                                {
                                        m_Box.Platinum = ( m_Box.Platinum - 1 );
                                        m_From.AddToBackpack( new PlatinumGranite() );
                                        m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                }
                                else
                                {
                                        m_From.SendMessage( "You do not have any of that granite!" );
                                        m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                }
                        }
                        /*if ( info.ButtonID == 6 )
                        {
                                if ( m_Box.Moonstone > 0 )
                                {
                                        m_Box.Moonstone = ( m_Box.Moonstone - 1 );
                                        m_From.AddToBackpack( new MoonstoneGranite() );
                                        m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                }
                                else
                                {
                                        m_From.SendMessage( "You do not have any of that granite!" );
                                        m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                }
                        }
                        if ( info.ButtonID == 7 )
                        {
                                if ( m_Box.Sunstone > 0 )
                                {
                                        m_Box.Sunstone = ( m_Box.Sunstone - 1 );
                                        m_From.AddToBackpack( new SunstoneGranite() );
                                        m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                }
                                else
                                {
                                        m_From.SendMessage( "You do not have any of that granite!" );
                                        m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                }
                        }
                        if ( info.ButtonID == 8 )
                        {
                                if ( m_Box.Bloodstone > 0 )
                                {
                                        m_Box.Bloodstone = ( m_Box.Bloodstone - 1 );
                                        m_From.AddToBackpack( new BloodstoneGranite() );
                                        m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                }
                                else
                                {
                                        m_From.SendMessage( "You do not have any of that granite!" );
                                        m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                }
                        }
                        if ( info.ButtonID == 9 )
                        {
                                if ( m_Box.Vulcan > 0 )
                                {
                                        m_Box.Vulcan = ( m_Box.Vulcan - 1 );
                                        m_From.AddToBackpack( new VulcanGranite() );
                                        m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                }
                                else
                                {
                                        m_From.SendMessage( "You do not have any of that granite!" );
                                        m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                }
                        }
                        if ( info.ButtonID == 10 )
                        {
                                if ( m_Box.Aqua > 0 )
                                {
                                	m_Box.Aqua = ( m_Box.Aqua - 1 );
                                	m_From.AddToBackpack( new AquaGranite() );
                                	m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                }
                                else
                                {
                                	m_From.SendMessage( "You do not have any of that granite!" );
                                	m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                }
                   	}*/
					// END RWR
                   	if ( info.ButtonID == 9 )
                   	{
                   		m_From.SendGump( new NewGraniteBoxGump( m_From, m_Box ) );
                                m_Box.BeginCombine( m_From );
                        }
                }
        }

}

namespace Server.Items
{
        public class NewGraniteBoxTarget : Target
        {
                private NewGraniteBox m_Box;

                public NewGraniteBoxTarget( NewGraniteBox box ) : base( 18, false, TargetFlags.None )
                {
                        m_Box = box;
                }

                protected override void OnTarget( Mobile from, object targeted )
                {
                        if ( m_Box.Deleted )
                                return;

                        m_Box.EndCombine( from, targeted );
                }
        }
}
