using System;
using Server;

namespace Server.Items
{
	public class RewardForgeAddon : BaseAddon
	{
		public override BaseAddonDeed Deed{ get{ return new RewardForgeDeed(); } }

		[Constructable]
		public RewardForgeAddon()
		{
			AddComponent( new ForgeComponent( 0xFB1 ), 0, 0, 0 );
			// RWR MODIFY HUE LIST FOR PERN ORES
			Hue = Utility.RandomList(0x973, 0x966, 0x96D, 0x972, 0x8A5, 0x979, 0x89F, 0x8AB, 1161, 1152, 1272, 1278, 1153);
			// END RWR
		}

		public RewardForgeAddon( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}

	public class RewardForgeDeed : BaseAddonDeed
	{
		public override BaseAddon Addon{ get{ return new RewardForgeAddon(); } }
		public override int LabelNumber{ get{ return 1044330; } } // small forge

		[Constructable]
		public RewardForgeDeed()
		{
			Name = "Deed for a Reward Forge";
		}

		public RewardForgeDeed( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}
}